Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp	(revision 88)
@@ -22,5 +22,6 @@
   void Decod::genMealy (void)
   {
-    log_printf(TRACE,Decod,FUNCTION,"Begin");
+    log_begin(Decod,FUNCTION);
+    log_function(Decod,FUNCTION,_name.c_str());
 
     //-----------------------------------
@@ -38,4 +39,5 @@
       {
 	decod_val   [i] = false;
+	predict_val [i] = false;
       }
 
@@ -57,18 +59,16 @@
     //-----------------------------------
     // scan all decod "slot_out"
-    log_printf(TRACE,Decod,FUNCTION,"KANE LIVE");    
-    std::list<select_t>::iterator it=select.begin();
+    std::list<generic::priority::select_t> * select = _priority->select();
+    std::list<generic::priority::select_t>::iterator it=select->begin();
     for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
       {
-	while ((it != select.end())     and  // have a no scanned "slot_in" ?
+	while ((it != select->end())    and  // have a no scanned "slot_in" ?
 	       (decod_val [i] == false) and  // have not a previous selected entry?
 	       (context_event_val == false)) // Have not a context_event (spr_access, exception, ...)
 	  {
-	    log_printf(TRACE,Decod,FUNCTION,"loop");    
-
 	    predict_val [i] = false;
 
-	    Tcontext_t x = it->_context ;
-	    uint32_t   y = it->_inst_fetch;
+	    Tcontext_t x = it->grp;
+	    uint32_t   y = it->elt;
 
 	    // Test if this instruction is valid
@@ -76,5 +76,7 @@
 		(can_continue [x]                == 1))    // context can decod instruction (have not a previous event)
 	      {
-		can_continue      [x] = can_continue_next [x];
+                log_printf(TRACE,Decod,FUNCTION,"  * IFETCH [%d][%d]",x,y);    
+
+		can_continue [x] = can_continue_next [x];
 
 		decod_val  [i]    = true;                        // fetch_val and decod_enable 
@@ -90,21 +92,47 @@
 		_decod_instruction->_is_delay_slot    = internal_CONTEXT_IS_DELAY_SLOT [x];
 
-		// Decod !
-		log_printf(TRACE,Decod,FUNCTION,"DECOD [%d]",i);
-		log_printf(TRACE,Decod,FUNCTION,"  * context       : %d",x);
-		log_printf(TRACE,Decod,FUNCTION,"  * fetch         : %d",y);
-		log_printf(TRACE,Decod,FUNCTION,"  * address       : %.8x",addr);
-		log_printf(TRACE,Decod,FUNCTION,"  * is_delay_slot : %d",internal_CONTEXT_IS_DELAY_SLOT [x]);
-
-		instruction_decod (_decod_instruction, _decod_param[x]);
-
-		Ttype_t type = _decod_instruction->_type;
+                // Test IFetch exception
+                Texception_t ifetch_exception = PORT_READ(in_IFETCH_EXCEPTION [x]);
+
+                if (ifetch_exception == EXCEPTION_IFETCH_NONE)
+                  {
+                    // Decod !
+                    log_printf(TRACE,Decod,FUNCTION,"  * DECOD [%d]",i);
+                    log_printf(TRACE,Decod,FUNCTION,"    * context       : %d",x);
+                    log_printf(TRACE,Decod,FUNCTION,"    * fetch         : %d",y);
+                    log_printf(TRACE,Decod,FUNCTION,"    * address       : %.8x (%.8x)",addr,(addr<<2));
+                    log_printf(TRACE,Decod,FUNCTION,"    * is_delay_slot : %d",internal_CONTEXT_IS_DELAY_SLOT [x]);
+                    
+                    instruction_decod (_decod_instruction, _decod_param[x]);
+                  }
+                else
+                  {
+                    // No decod : nop
+                    instruction_l_nop (_decod_instruction, _decod_param[x]);
+
+                    _decod_instruction->_exception_use = EXCEPTION_USE_NONE;
+                    _decod_instruction->_exception     = exception_ifetch_to_exception_decod(ifetch_exception);
+                    
+                    // INSTRUCTION_TLB  
+                    // INSTRUCTION_PAGE 
+                    // BUS_ERROR        
+                    if (_decod_instruction->_is_delay_slot)
+                      _decod_instruction->_address_next       = _decod_instruction->_address_previous;
+                    else
+                      _decod_instruction->_address_next       = _decod_instruction->_address;
+                    
+                    _decod_instruction->_event_type         = EVENT_TYPE_EXCEPTION;
+                  }
+
+		Ttype_t  type  = _decod_instruction->_type;
+                Tdepth_t depth = (_param->_have_port_depth)?PORT_READ(in_CONTEXT_DEPTH [x]):0; // DEPTH_CURRENT
 
 		if (_param->_have_port_context_id)
 		PORT_WRITE(out_DECOD_CONTEXT_ID    [i], x);
 		if (_param->_have_port_depth)
-		PORT_WRITE(out_DECOD_DEPTH         [i], PORT_READ(in_CONTEXT_DEPTH [x]));
+                PORT_WRITE(out_DECOD_DEPTH         [i], depth);
 		PORT_WRITE(out_DECOD_TYPE          [i], type);
 		PORT_WRITE(out_DECOD_OPERATION     [i], _decod_instruction->_operation     );
+ 		PORT_WRITE(out_DECOD_NO_EXECUTE    [i], _decod_instruction->_no_execute    );
 		PORT_WRITE(out_DECOD_IS_DELAY_SLOT [i], _decod_instruction->_is_delay_slot );
 		PORT_WRITE(out_DECOD_ADDRESS       [i], addr);
@@ -122,8 +150,11 @@
 		PORT_WRITE(out_DECOD_NUM_REG_RE    [i], _decod_instruction->_num_reg_re    );
 		PORT_WRITE(out_DECOD_EXCEPTION_USE [i], _decod_instruction->_exception_use );
+// 		PORT_WRITE(out_DECOD_EXCEPTION     [i], _decod_instruction->_exception     );
 
 		if (type == TYPE_BRANCH)
 		  {
-		    log_printf(TRACE,Decod,FUNCTION,"  * type is branch");
+		    log_printf(TRACE,Decod,FUNCTION,"    * type is branch");
+		    log_printf(TRACE,Decod,FUNCTION,"      * address src  : %.8x (%.8x)",_decod_instruction->_address     ,_decod_instruction->_address     <<2);
+		    log_printf(TRACE,Decod,FUNCTION,"      * address dest : %.8x (%.8x)",_decod_instruction->_address_next,_decod_instruction->_address_next<<2);
 
 		    predict_val [i]     = ifetch_ack  [x][y] // and decod_val [i]
@@ -136,6 +167,6 @@
 		    PORT_WRITE(out_PREDICT_MATCH_INST_IFETCH_PTR       [i],y == ((_param->_have_port_inst_ifetch_ptr)?PORT_READ(in_IFETCH_INST_IFETCH_PTR [x]):0));
 		    PORT_WRITE(out_PREDICT_BRANCH_STATE                [i],PORT_READ(in_IFETCH_BRANCH_STATE                [x]));
-		    if (_param->_have_port_branch_update_prediction_id)
-		    PORT_WRITE(out_PREDICT_BRANCH_UPDATE_PREDICTION_ID [i],PORT_READ(in_IFETCH_BRANCH_UPDATE_PREDICTION_ID [x]));
+		    if (_param->_have_port_depth)
+                    PORT_WRITE(out_PREDICT_BRANCH_UPDATE_PREDICTION_ID [i],PORT_READ(in_IFETCH_BRANCH_UPDATE_PREDICTION_ID [x]));
 		    PORT_WRITE(out_PREDICT_BRANCH_CONDITION            [i],_decod_instruction->_branch_condition  );
 // 		    PORT_WRITE(out_PREDICT_BRANCH_STACK_WRITE          [i],_decod_instruction->_branch_stack_write);
@@ -145,5 +176,5 @@
 		
 		    //can_continue_next [x] = PORT_READ(in_PREDICT_CAN_CONTINUE [i]); // can continue is set if direction is "not take" (also, continue is sequential order)
-		    can_continue_next [x] = false; // one branch per context
+		    can_continue_next [x] = false; // one branch per context, the DS don't execute
 		  }
 
@@ -160,4 +191,6 @@
 		    if (_param->_have_port_context_id)
 		    PORT_WRITE(out_CONTEXT_EVENT_CONTEXT_ID   , x);
+                    if (_param->_have_port_depth)
+		    PORT_WRITE(out_CONTEXT_EVENT_DEPTH        , depth);
 		    PORT_WRITE(out_CONTEXT_EVENT_TYPE         , _decod_instruction->_event_type    );
 		    PORT_WRITE(out_CONTEXT_EVENT_IS_DELAY_SLOT, _decod_instruction->_is_delay_slot );
@@ -184,9 +217,9 @@
 	      }
 
-	    log_printf(TRACE,Decod,FUNCTION,"  - num_(decod, context, fetch) : %d %d %d",i, x, y);
-	    log_printf(TRACE,Decod,FUNCTION,"    - ifetch_ack        : %d",ifetch_ack  [x][y]);
-	    log_printf(TRACE,Decod,FUNCTION,"    - context_event_val : %d",context_event_val );
-	    log_printf(TRACE,Decod,FUNCTION,"    - predict_val       : %d",predict_val [i]   );
-	    log_printf(TRACE,Decod,FUNCTION,"    - decod_val         : %d",decod_val   [i]   );
+	    log_printf(TRACE,Decod,FUNCTION,"    - num_(decod, context, fetch) : %d %d %d",i, x, y);
+	    log_printf(TRACE,Decod,FUNCTION,"      - ifetch_ack        : %d",ifetch_ack  [x][y]);
+	    log_printf(TRACE,Decod,FUNCTION,"      - context_event_val : %d",context_event_val );
+	    log_printf(TRACE,Decod,FUNCTION,"      - predict_val       : %d",predict_val [i]   );
+	    log_printf(TRACE,Decod,FUNCTION,"      - decod_val         : %d",decod_val   [i]   );
 	    
 	    it ++;
@@ -207,7 +240,11 @@
 	PORT_WRITE(out_PREDICT_VAL [i], predict_val [i]);
 	PORT_WRITE(out_DECOD_VAL   [i], decod_val   [i]);
-      }
-
-    log_printf(FUNC,Decod,FUNCTION,"End");
+        
+#ifdef STATISTICS
+        internal_DECOD_VAL [i] = decod_val [i];
+#endif
+      }
+
+    log_end(Decod,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_statistics_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_statistics_allocation.cpp	(revision 88)
@@ -27,11 +27,12 @@
 		      "Decod",
 		      param_statistics);
-   
-    _stat_sum_inst_decod = _stat->create_variable ("sum_inst_decod" // ,"", "Sum of decod instruction"
-						   );
 
+    _stat_sum_inst_decod = _stat->create_variable("sum_inst_decod");
+    
+    
+    _stat->create_expr_average_by_cycle ("average_nb_inst_decod","sum_inst_decod","","Average of decod instruction by cycle");
+    _stat->create_expr_percent          ("percent_nb_inst_decod","average_nb_inst_decod", toString(_param->_nb_inst_decod), "Percent of decod instruction by cycle");
+  
 
-    _stat->create_expr_average_by_cycle ("average_sum_inst_decod","sum_inst_decod","","Average of decod instruction by cycle");
-    _stat->create_expr_percent          ("percent_sum_inst_decod","average_sum_inst_decod", toString(_param->_nb_inst_decod), "Percent of decod instruction by cycle");
  
     log_printf(FUNC,Decod,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_transition.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_transition.cpp	(revision 88)
@@ -22,9 +22,9 @@
   void Decod::transition (void)
   {
-    log_printf(FUNC,Decod,FUNCTION,"Begin");
+    log_begin(Decod,FUNCTION);
 
     if (PORT_READ(in_NRESET) == 0)
       {
-	reg_CONTEXT_PRIORITY = 0;
+	_priority->reset();
 
 	for (uint32_t i=0; i<_param->_nb_context; i++)
@@ -36,60 +36,5 @@
     else
       {
-	switch (_param->_priority)
-	  {
-// 	  case PRIORITY_STATIC :
-// 	    {
-// 	      reg_CONTEXT_PRIORITY = (reg_CONTEXT_PRIORITY+_param->_nb_context_select)%_param->_nb_context;
-// 	      break;
-// 	    }
-	  case PRIORITY_ROUND_ROBIN :
-	    {
-	      reg_CONTEXT_PRIORITY = (reg_CONTEXT_PRIORITY+1                         )%_param->_nb_context;
-	      break;
-	    }
-	  default:
-	    {
-	      break;
-	    }
-	  }
-
-	// flush list
-	select.clear();
-	
-	// Compute next scan order !!!
-	switch (_param->_load_balancing)
-	  {
-// 	  case LOAD_BALANCING_BALANCE :
-// 	    {
-// 	      for (uint32_t j=0; j<_param->_max_nb_inst_fetch; j++)
-// 		for (uint32_t i=0; i<_param->_nb_context_select; i++)
-// 		  {
-// 		    uint32_t x=(reg_CONTEXT_PRIORITY+i)%_param->_nb_context;
-		    
-// 		    // Test valid inst_fetch
-// 		    if (j < _param->_nb_inst_fetch[x])
-// 		      select.push_back(select_t(x,j));
-// 		  }
-		  
-// 	      break;
-// 	    }
-	  case LOAD_BALANCING_MAXIMUM_FOR_PRIORITY :
-	    {
-
-	      for (uint32_t i=0; i<_param->_nb_context_select; i++)
-		{
-		  uint32_t x=(reg_CONTEXT_PRIORITY+i)%_param->_nb_context;
-		  
-		  for (uint32_t j=0; j<_param->_nb_inst_fetch[x]; j++)
-		    select.push_back(select_t(x,j));
-		}
-
-	      break;
-	    }
-	  default :
-	    {
-	      break;
-	    }
-	  }
+	_priority->transition();
 
 	// Compute "next previous" address
@@ -97,8 +42,4 @@
 	  if (internal_CONTEXT_HAVE_TRANSACTION[i])
 	    {
-#ifdef STATISTICS
-	      (*_stat_sum_inst_decod) ++;
-#endif
-
 	      reg_CONTEXT_ADDRESS_PREVIOUS [i] = internal_CONTEXT_ADDRESS_PREVIOUS [i];
 	      reg_CONTEXT_IS_DELAY_SLOT    [i] = internal_CONTEXT_IS_DELAY_SLOT    [i];
@@ -107,4 +48,11 @@
 // 	for (uint32_t i=0; i<_param->_nb_context; i++)
 // 	  log_printf(TRACE,Decod,FUNCTION,"[%d] %.8x %d",i,reg_CONTEXT_ADDRESS_PREVIOUS [i], reg_CONTEXT_IS_DELAY_SLOT [i]);
+
+#ifdef STATISTICS
+        if (usage_is_set(_usage,USE_STATISTICS))
+          for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+            if (internal_DECOD_VAL [i] and PORT_READ(in_DECOD_ACK[i]))
+              (*_stat_sum_inst_decod) ++;
+#endif
       }
 
@@ -113,5 +61,5 @@
 #endif
 
-    log_printf(FUNC,Decod,FUNCTION,"End");
+    log_end(Decod,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters.cpp	(revision 88)
@@ -1,4 +1,3 @@
 /*
-
  * $Id$
  *
@@ -24,6 +23,6 @@
 			  uint32_t          * nb_inst_fetch                ,
 			  uint32_t            nb_inst_decod                ,
-			  uint32_t            nb_branch_speculated         ,
-			  uint32_t            size_branch_update_prediction,
+			  uint32_t          * nb_branch_speculated         ,
+// 			  uint32_t          * size_branch_update_prediction,
 			  uint32_t            nb_context_select            ,
 			  uint32_t            size_general_data            ,
@@ -31,5 +30,7 @@
 			  Tload_balancing_t   load_balancing               ,
 			  bool             ** instruction_implemeted       ,
-			  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (uint32_t))
+			  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void),
+                          bool                is_toplevel
+                          )
   {
     log_printf(FUNC,Decod,FUNCTION,"Begin");
@@ -40,6 +41,6 @@
     _nb_branch_speculated          = nb_branch_speculated         ;
     _nb_context_select             = nb_context_select            ;
-    _size_branch_update_prediction = size_branch_update_prediction;
-    _size_general_data             = size_general_data            ;
+//  _size_branch_update_prediction = size_branch_update_prediction;
+//  _size_general_data             = size_general_data            ;
     _priority                      = priority                     ;
     _load_balancing                = load_balancing               ;
@@ -52,17 +53,27 @@
 
     
-    _max_nb_inst_fetch                     = max<uint32_t>(nb_inst_fetch,nb_context);
+    _max_nb_inst_fetch                        = max<uint32_t>(nb_inst_fetch,nb_context);
+                                              
+//  _size_address_inst                        = size_general_data-2;
 
-    _size_address_inst                     = size_general_data-2;
-    _size_context_id                       = log2(nb_context          );
-    _size_depth                            = log2(nb_branch_speculated);
-    _size_inst_ifetch_ptr                  = log2(_max_nb_inst_fetch  );
+    test();
 
-    _have_port_context_id                  = _size_context_id > 0;
-    _have_port_depth                       = _size_depth      > 0;
-    _have_port_branch_update_prediction_id = _size_branch_update_prediction > 0;
-    _have_port_inst_ifetch_ptr             = _size_inst_ifetch_ptr > 0;
-    
-    test();
+    if (is_toplevel)
+      {
+        _size_context_id                      = log2(nb_context          );
+        _size_depth                           = log2(max<uint32_t>(_nb_branch_speculated,_nb_context));
+//      _size_branch_update_prediction_id     = max<uint32_t>(_size_branch_update_prediction,_nb_context);
+        _size_inst_ifetch_ptr                 = log2(_max_nb_inst_fetch  );
+        _size_instruction_address             = size_general_data-2;
+        _size_general_data                    = size_general_data;
+
+        _have_port_context_id                 = _size_context_id > 0;
+        _have_port_depth                      = _size_depth                       > 0;
+//      _have_port_branch_update_prediction_id= _size_branch_update_prediction_id > 0;
+        _have_port_inst_ifetch_ptr            = _size_inst_ifetch_ptr             > 0;
+
+        copy ();
+      }
+
     log_printf(FUNC,Decod,FUNCTION,"End");
   };
@@ -82,4 +93,14 @@
   {
     log_printf(FUNC,Decod,FUNCTION,"Begin");
+
+    log_printf(FUNC,Decod,FUNCTION,"End");
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Decod::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Decod,FUNCTION,"Begin");
+
     log_printf(FUNC,Decod,FUNCTION,"End");
   };
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters_msg_error.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters_msg_error.cpp	(revision 88)
@@ -31,11 +31,11 @@
       test.error(_("nb_inst_decod must be > 0.\n"));
 
-    if ((_size_general_data != 32) and
-	(_size_general_data != 64))
-      test.error(_("size_general_data must be equal at 32 or 64 bits.\n"));
+//  if ((_size_general_data != 32) and
+//      (_size_general_data != 64))
+//    test.error(_("size_general_data must be equal at 32 or 64 bits.\n"));
 
-    if ((_nb_branch_speculated == 0) or
-	(_nb_branch_speculated > _nb_context))
-      test.error(_("nb_branch_speculated must be in [1:nb_context].\n"));
+//     if ((_nb_branch_speculated == 0) or
+// 	(_nb_branch_speculated > _nb_context))
+//       test.error(_("nb_branch_speculated must be in [1:nb_context].\n"));
 
     if ((_nb_context_select == 0) or
@@ -48,5 +48,5 @@
 
     if (sum_inst_fetch < _nb_inst_decod)
-      test.error(_("The sum of the _nb_context_select most nb_inst_fetch must be greater that _nb_inst_decod"));
+      test.error(_("The sum of the _nb_context_select most nb_inst_fetch must be greater that _nb_inst_decod\n"));
 
     if ((_priority != PRIORITY_ROUND_ROBIN))
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Parameters_print.cpp	(revision 88)
@@ -30,5 +30,5 @@
     xml.singleton_begin("nb_inst_decod                "); xml.attribut("value",toString(_nb_inst_decod                )); xml.singleton_end();
     xml.singleton_begin("nb_branch_speculated         "); xml.attribut("value",toString(_nb_branch_speculated         )); xml.singleton_end();
-    xml.singleton_begin("size_branch_update_prediction"); xml.attribut("value",toString(_size_branch_update_prediction)); xml.singleton_end();
+//  xml.singleton_begin("size_branch_update_prediction"); xml.attribut("value",toString(_size_branch_update_prediction)); xml.singleton_end();
     xml.singleton_begin("nb_context_select            "); xml.attribut("value",toString(_nb_context_select            )); xml.singleton_end();
     xml.singleton_begin("size_general_data            "); xml.attribut("value",toString(_size_general_data            )); xml.singleton_end();
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Decod_queue_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/src/main.cpp	(revision 88)
@@ -55,5 +55,7 @@
 	 _size_queue       ,
 	 _size_general_data,
-	 _nb_branch_speculated);
+	 _nb_branch_speculated,
+         true // is_toplevel
+         );
       
       msg(_("%s"),param->print(1).c_str());
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/SelfTest/src/test.cpp	(revision 88)
@@ -58,4 +58,5 @@
   ALLOC1_SC_SIGNAL( in_DECOD_IN_TYPE           ," in_DECOD_IN_TYPE          ",Ttype_t            ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL( in_DECOD_IN_OPERATION      ," in_DECOD_IN_OPERATION     ",Toperation_t       ,_param->_nb_inst_decod);
+  ALLOC1_SC_SIGNAL( in_DECOD_IN_NO_EXECUTE     ," in_DECOD_IN_NO_EXECUTE    ",Tcontrol_t         ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL( in_DECOD_IN_IS_DELAY_SLOT  ," in_DECOD_IN_IS_DELAY_SLOT ",Tcontrol_t         ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL( in_DECOD_IN_ADDRESS        ," in_DECOD_IN_ADDRESS       ",Tgeneral_data_t    ,_param->_nb_inst_decod);
@@ -73,4 +74,5 @@
   ALLOC1_SC_SIGNAL( in_DECOD_IN_NUM_REG_RE     ," in_DECOD_IN_NUM_REG_RE    ",Tspecial_address_t ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL( in_DECOD_IN_EXCEPTION_USE  ," in_DECOD_IN_EXCEPTION_USE ",Texception_t       ,_param->_nb_inst_decod);
+  ALLOC1_SC_SIGNAL( in_DECOD_IN_EXCEPTION      ," in_DECOD_IN_EXCEPTION     ",Texception_t       ,_param->_nb_inst_decod);
 									                          
   ALLOC1_SC_SIGNAL(out_DECOD_OUT_VAL           ,"out_DECOD_OUT_VAL          ",Tcontrol_t         ,_param->_nb_inst_decod);
@@ -80,4 +82,5 @@
   ALLOC1_SC_SIGNAL(out_DECOD_OUT_TYPE          ,"out_DECOD_OUT_TYPE         ",Ttype_t            ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_OUT_OPERATION     ,"out_DECOD_OUT_OPERATION    ",Toperation_t       ,_param->_nb_inst_decod);
+  ALLOC1_SC_SIGNAL(out_DECOD_OUT_NO_EXECUTE    ,"out_DECOD_OUT_NO_EXECUTE   ",Tcontrol_t         ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_OUT_IS_DELAY_SLOT ,"out_DECOD_OUT_IS_DELAY_SLOT",Tcontrol_t         ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_OUT_ADDRESS       ,"out_DECOD_OUT_ADDRESS      ",Tgeneral_data_t    ,_param->_nb_inst_decod);
@@ -95,7 +98,8 @@
   ALLOC1_SC_SIGNAL(out_DECOD_OUT_NUM_REG_RE    ,"out_DECOD_OUT_NUM_REG_RE   ",Tspecial_address_t ,_param->_nb_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_OUT_EXCEPTION_USE ,"out_DECOD_OUT_EXCEPTION_USE",Texception_t       ,_param->_nb_inst_decod);
+  ALLOC1_SC_SIGNAL(out_DECOD_OUT_EXCEPTION     ,"out_DECOD_OUT_EXCEPTION    ",Texception_t       ,_param->_nb_inst_decod);
 									                          
-  ALLOC1_SC_SIGNAL( in_DEPTH_TAIL              ," in_DEPTH_TAIL             ",Tdepth_t           ,_param->_nb_context);
-  ALLOC1_SC_SIGNAL( in_DEPTH_NB_BRANCH         ," in_DEPTH_NB_BRANCH        ",Tdepth_t           ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL( in_DEPTH_MIN               ," in_DEPTH_MIN              ",Tdepth_t           ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL( in_DEPTH_MAX               ," in_DEPTH_MAX              ",Tdepth_t           ,_param->_nb_context);
 
   ALLOC1_SC_SIGNAL(out_NB_INST_ALL             ,"out_NB_INST_ALL            ",Tcounter_t         ,_param->_nb_context);
@@ -118,4 +122,5 @@
   INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_IN_TYPE           ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_IN_OPERATION      ,_param->_nb_inst_decod);
+  INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_IN_NO_EXECUTE     ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_IN_IS_DELAY_SLOT  ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_IN_ADDRESS        ,_param->_nb_inst_decod);
@@ -133,5 +138,6 @@
   INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_IN_NUM_REG_RE     ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_IN_EXCEPTION_USE  ,_param->_nb_inst_decod);
-  
+  INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_IN_EXCEPTION      ,_param->_nb_inst_decod);
+
   INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_VAL           ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue, in_DECOD_OUT_ACK           ,_param->_nb_inst_decod);
@@ -142,4 +148,5 @@
   INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_TYPE          ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_OPERATION     ,_param->_nb_inst_decod);
+  INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_NO_EXECUTE    ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_IS_DELAY_SLOT ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_ADDRESS       ,_param->_nb_inst_decod);
@@ -157,10 +164,10 @@
   INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_NUM_REG_RE    ,_param->_nb_inst_decod);
   INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_EXCEPTION_USE ,_param->_nb_inst_decod);
-  
-  if (_param->_have_port_depth)
-    {
-  INSTANCE1_SC_SIGNAL(_Decod_queue, in_DEPTH_TAIL              ,_param->_nb_context);
-  INSTANCE1_SC_SIGNAL(_Decod_queue, in_DEPTH_NB_BRANCH         ,_param->_nb_context);
-    }
+  INSTANCE1_SC_SIGNAL(_Decod_queue,out_DECOD_OUT_EXCEPTION     ,_param->_nb_inst_decod);
+
+  for (uint32_t i=0; i<_param->_nb_context; ++i)
+    if (_param->_have_port_depth)
+      INSTANCE_SC_SIGNAL(_Decod_queue, in_DEPTH_MIN  [i]);
+  INSTANCE1_SC_SIGNAL(_Decod_queue, in_DEPTH_MAX               ,_param->_nb_context);
   
   INSTANCE1_SC_SIGNAL(_Decod_queue,out_NB_INST_ALL             ,_param->_nb_context);
@@ -293,4 +300,5 @@
   DELETE1_SC_SIGNAL( in_DECOD_IN_TYPE           ,_param->_nb_inst_decod);
   DELETE1_SC_SIGNAL( in_DECOD_IN_OPERATION      ,_param->_nb_inst_decod);
+  DELETE1_SC_SIGNAL( in_DECOD_IN_NO_EXECUTE     ,_param->_nb_inst_decod);
   DELETE1_SC_SIGNAL( in_DECOD_IN_IS_DELAY_SLOT  ,_param->_nb_inst_decod);
   DELETE1_SC_SIGNAL( in_DECOD_IN_ADDRESS        ,_param->_nb_inst_decod);
@@ -308,4 +316,5 @@
   DELETE1_SC_SIGNAL( in_DECOD_IN_NUM_REG_RE     ,_param->_nb_inst_decod);
   DELETE1_SC_SIGNAL( in_DECOD_IN_EXCEPTION_USE  ,_param->_nb_inst_decod);
+  DELETE1_SC_SIGNAL( in_DECOD_IN_EXCEPTION      ,_param->_nb_inst_decod);
 
   DELETE1_SC_SIGNAL(out_DECOD_OUT_VAL           ,_param->_nb_inst_decod);
@@ -315,4 +324,5 @@
   DELETE1_SC_SIGNAL(out_DECOD_OUT_TYPE          ,_param->_nb_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_OUT_OPERATION     ,_param->_nb_inst_decod);
+  DELETE1_SC_SIGNAL(out_DECOD_OUT_NO_EXECUTE    ,_param->_nb_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_OUT_IS_DELAY_SLOT ,_param->_nb_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_OUT_ADDRESS       ,_param->_nb_inst_decod);
@@ -330,7 +340,8 @@
   DELETE1_SC_SIGNAL(out_DECOD_OUT_NUM_REG_RE    ,_param->_nb_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_OUT_EXCEPTION_USE ,_param->_nb_inst_decod);
-
-  DELETE1_SC_SIGNAL( in_DEPTH_TAIL              ,_param->_nb_context);
-  DELETE1_SC_SIGNAL( in_DEPTH_NB_BRANCH         ,_param->_nb_context);
+  DELETE1_SC_SIGNAL(out_DECOD_OUT_EXCEPTION     ,_param->_nb_inst_decod);
+
+  DELETE1_SC_SIGNAL( in_DEPTH_MIN               ,_param->_nb_context);
+  DELETE1_SC_SIGNAL( in_DEPTH_MAX               ,_param->_nb_context);
 
   DELETE1_SC_SIGNAL(out_NB_INST_ALL             ,_param->_nb_context);
